def _render(request, name, *args, **kwargs):
    context_class = get_context_class(name)
    if context_class is None:
        raise Exception()

    context = context_class()
    try:
        data = context.get_context(request, *args, **kwargs, include_data=False)
        data["context"] = json.dumps(data["context"])
        print("context", context.need_auth, data)
    except UnauthorizedException as err:
        return _render(request, "login", data={"error" : str(err)})

    data.update({"debug": False})
    ret = render(request, "index.html", data)
    return ret

def render_page(name):
    return lambda request, *args, name=name, **kwargs: _render(request, name, *args, **kwargs)
